#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100;

struct segment
{
    int x1, y1, x2, y2;
};

int n;
segment segments[MAXN + 5];
int diffx[MAXN + 5], diffy[MAXN + 5];
vector<int> mat[512][512];
int a[128][128];
bool used[MAXN + 5];
int ans = 0;

void DFS(int u, int d)
{
    used[u] = true;
    ans = max(ans, d);
    for (int i = 1; i <= n; ++ i)
    {
        if (!used[i] and a[u][i] == 1)
        {
            DFS(i, d + 1);
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> segments[i].x1 >> segments[i].y1 >> segments[i].x2 >> segments[i].y2;
        int d = __gcd(segments[i].x2 - segments[i].x1, segments[i].y2 - segments[i].y1);
        diffx[i] = (segments[i].x2 - segments[i].x1) / d;
        diffy[i] = (segments[i].y2 - segments[i].y1) / d;
    }

    for (int i = 1; i <= n; ++ i)
    {
        int x1 = segments[i].x1, x2 = segments[i].x2, y1 = segments[i].y1, y2 = segments[i].y2;
        while(x1 != x2 or y1 != y2)
        {
            int s = mat[x1 + 250][y1 + 250].size();
            for (int j = 0; j < s; ++ j)
            {
                a[i][mat[x1 + 250][y1 + 250][j]] = a[mat[x1 + 250][y1 + 250][j]][i] = 1;
            }
            mat[x1 + 250][y1 + 250].push_back(i);
            x1 += diffx[i];
            y1 += diffy[i];
        }
    }

    /*for (int i = 1; i <= n; ++ i)
    {
        DFS(i, 1);
    }

    cout << ans << endl;*/

    return 0;
}
