#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#define endl '\n'
using namespace std;

const int MAXN = 100;

struct segment
{
    int x1, y1, x2, y2;
};

int n;
segment segments[MAXN + 5];
int diffx[MAXN + 5], diffy[MAXN + 5];
vector<int> mat[512][512];
int a[128][128];
vector<int> G[MAXN + 5];
bool used[MAXN + 5];
int ans = 0;

void DFS(int u, int d)
{
    used[u] = true;
    ans = max(ans, d);
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (!used[v])
        {
            DFS(v, d + 1);
        }
    }
    used[u] = false;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> segments[i].x1 >> segments[i].y1 >> segments[i].x2 >> segments[i].y2;
        int d = __gcd(abs(segments[i].x2 - segments[i].x1), abs(segments[i].y2 - segments[i].y1));
        diffx[i] = (segments[i].x2 - segments[i].x1) / d;
        diffy[i] = (segments[i].y2 - segments[i].y1) / d;
    }

    for (int i = 1; i <= n; ++ i)
    {
        int x1 = segments[i].x1, x2 = segments[i].x2, y1 = segments[i].y1, y2 = segments[i].y2;
        int d = __gcd(abs(x2 - x1), abs(y2 - y1));
        for (int j = 1; j <= d + 1; ++ j)
        {
            int s = mat[x1 + 250][y1 + 250].size();
            for (int k = 0; k < s; ++ k)
            {
                if (a[i][mat[x1 + 250][y1 + 250][k]] == 0)
                {
                    G[i].push_back(mat[x1 + 250][y1 + 250][k]);
                    a[i][mat[x1 + 250][y1 + 250][k]] = a[mat[x1 + 250][y1 + 250][k]][i] = 1;
                }
            }
            mat[x1 + 250][y1 + 250].push_back(i);
            x1 += diffx[i];
            y1 += diffy[i];
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        DFS(i, 1);
    }

    cout << ans << endl;

    return 0;
}
