#include<iostream>
#include<algorithm>
#include<math.h>
#include<queue>
#include<stack>
#include<map>
#include<vector>

using namespace std;

class point
{
public:
    int x;
    int y;
};

class segment
{
public:
    point p1;
    point p2; 
};

segment arr[100];

point areColiding(segment a, segment b)
{
    point va;
    point vb;
    
    va.x = a.p2.x - a.p1.x; 
    va.y = a.p2.y - a.p1.y;
    
    vb.x = b.p2.x - b.p1.x; 
    vb.y = b.p2.y - b.p1.y;
    
    for(int i = 2;i <= max(va.x,va.y);i++)
    {
        if(va.x % i == 0  && va.y % i == 0)
        {
            va.x /= i;
            va.y /= i;
        }
    }
    
    for(int i = 2;i <= max(vb.x,vb.y);i++)
    {
        if(vb.x % i == 0  && vb.y % i == 0)
        {
            vb.x /= i;
            vb.y /= i;
        }
    }
    
    point now;
    
    now.x = a.p1.x;
    now.y = a.p1.y;
    
    while(now.x != a.p2.x || now.y != a.p2.y)
    {
        point now2;
        now2.x = b.p1.x;
        now2.y = b.p1.y;
        while(now2.x != b.p2.x || now2.y != b.p2.y)
        {
            if(now.x == now2.x && now.y == now2.y)
            {
                return now;
            }
            now2.x += vb.x;
            now2.y += vb.y;
        }
        now.x += va.x;
        now.y += va.y;
    }
    
    now.x = -255;
    
    return now;
}

int pbr;

bool m[255][255];

vector<int> points[255];

bool visited[255];

int dfs(int start)
{
    int br = 0;
    queue<int> next;
    
    next.push(start);
    visited[start] = true;
    
    while(!next.empty())
    {
        int now = next.front();
        next.pop();
        br++;
        
        for(int i = 0;i < pbr;i++)
        {
            if(visited[i] == false)
            {
                next.push(i);
                visited[i] = true;
            }
        }
    }
    
    return br;
}

int main()
{
    /*
    segment a;
    segment b;
    
    a.p1.x = 0;
    a.p1.y = 0;
    a.p2.x = 10;
    a.p2.y = 4;
    
    b.p1.x = 0;
    b.p1.y = 3;
    b.p2.x = 5;
    b.p2.y = 3;
    
    
    areColiding(a,b);
    */
    int n;
    cin>>n;
    for(int i = 0;i < n;i++)
    {
        cin>>arr[i].p1.x;
        cin>>arr[i].p1.y;
        cin>>arr[i].p2.x;
        cin>>arr[i].p2.y;
        
        for(int j = 0;j < i;j++)
        {
            if((arr[i].p1.x == arr[j].p1.x && arr[i].p1.y == arr[j].p1.y && arr[i].p2.x == arr[j].p2.x && arr[i].p2.y == arr[j].p2.y) || (arr[i].p1.x == arr[j].p2.x && arr[i].p1.y == arr[j].p2.y && arr[i].p2.x == arr[j].p1.x && arr[i].p2.y == arr[j].p1.y))
            {
                i--;
                n--;
                break;
            }
        }
    }
    
    for(int i = 0;i < n;i++)
    {
        int s = pbr;
        for(int j = i + 1;j < n;j++)
        {
            point col = areColiding(arr[i], arr[j]);
            if(col.x != -255)
            {
                int pbr2 = pbr - 1;
                
                points[i].push_back(pbr);
                points[j].push_back(pbr);
                
                pbr++;
            }
        }
    }
    
    for(int i = 0;i < n;i++)
    {
        for(int j = 0;j < points[i].size();j++)
        {
            for(int k = j + 1;k < points[i].size();k++)
            {
                m[points[i][j]][points[i][k]] = true;
                m[points[i][k]][points[i][j]] = true;
            }
        }
    }
    
    int maxx = dfs(0);
    
    for(int i = 0;i < pbr;i++)
    {
        if(!visited[i])
        {
            int d = dfs(i);
            
            if(d > maxx)
            {
                maxx = d;
            }
        }
    }
    
    cout<<maxx + 1<<endl;
}



