#include <iostream>
#include <unordered_set>
#include <vector>
#include <string.h>
#include <cassert>
using namespace std;
#define endl '\n'
#define MAXN 105
#define uset unordered_set
#define int long long
int br;
struct point{
    int x, y;
    point(int a, int b) : x(a), y(b) {}
    point(){}
};
struct segment{
    point a, b;
    segment(point x, point y){
        a = x; b = y;
    }
    segment(){}
};
segment arr[MAXN];
vector<int> intersect;
uset<int> graph[MAXN];
int oriented(point a, point b){
    return (a.x - b.x) * (a.y + b.y);
}
bool colinear(point a, point b, point c){
    if(a.x > b.x && a.x > c.x) return false;
    if(a.x < b.x && a.x < c.x) return false;
    if(a.y > b.y && a.y > c.y) return false;
    if(a.y < b.y && a.y < c.y) return false;
    return oriented(a, b) + oriented(b, c) + oriented(c, a) == 0;
}
int maximum;
int u[MAXN];
void dfs(int vertex, int dep)
{
    u[vertex] = 1; maximum = max(maximum, dep);
    for(int att : graph[vertex]){
        if(u[att]) continue;
        dfs(att, dep + 1);
    }
}
signed main()
{
    cin.tie(0); ios::sync_with_stdio(false);
    cin >> br;
    for(int i = 0; i < br; ++i){
        int x1, y1, x2, y2; cin >> x1 >> y1 >> x2 >> y2;
        arr[i] = segment(point(x1, y1), point(x2, y2));
    }
    for(int i = -250; i <= 250; ++i){
        for(int z = -250; z <= 250; ++z){
            intersect = vector<int>();
            for(int q = 0; q < br; ++q){
                if(colinear(point(i, z), arr[q].a, arr[q].b)){
                    intersect.push_back(q);
                    //cout << "COL: " << i << ' ' << z << ' ' << q << endl;
                }
            }
            for(int w = 0; w < intersect.size(); ++w){
                for(int e = w + 1; e < intersect.size(); ++e){
                    int from = intersect[w], to = intersect[e];
                    graph[from].insert(to); graph[to].insert(from);
                }
            }
        }
    }
   // for(int i = 0; i < br; ++i){
     //   cout << i << ": ";
    //    for(int z : graph[i]) cout << z << ' ';
    //    cout << endl;
    //}
    for(int i = 0; i < br; ++i){
        memset(u, 0, sizeof(u));
        dfs(i, 1);
    }
    if(maximum > 25) assert(false);
    cout << maximum << endl;
    return 0;
}
